



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Fluent UDF【7】：解释型UDF</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Fluent UDF【7】：解释型UDF</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:20:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>UDF宏有两种方式可以被Fluent所接受:编译和解释。其中有一些宏既可以被解释也可以被编译，而一些宏则只能被解释。有一些场合只接受编译后的UDF(如动网格中的一些宏)，而有些场合既可以接受编译的UDF，还能接受解释后的UDF。那么解释型的UDF与编译型的UDF到底存在何种差异？本文主要描述解释型UDF，而编译型UDF涉及到的问题更多，我们留到下次再说。</p>
<h1>解释型UDF</h1>
<p>解释型UDF不需要额外的编译器，利用Fluent软件自身即可解释源代码。在解释过程中，UDF源代码被C预处理器解释成中间的，独立于计算机体系之外的机器代码。之后在调用UDF的过程中，这些被解释器生成的机器代码将在内部仿真器或解释器上被执行。当然，这种以解释的方式运行无可避免的会损失计算性能。但是以解释方式运行的UDF有个好处:<strong>其可以不加修改的在不同体系的计算机上、不同的操作系统以及不同的Fluent版本中运行</strong>。<br />
<strong>当UDF的计算性能很重要时，建议以编译的形式运行UDF。所有解释型UDF都可以以编译的方式被Fluent加载。</strong><br />
在UDF被解释后保存cas文件，之后再打开cas文件时，UDF能够直接被加载，而无需重新解释。</p>
<h1>解释型UDF的局限性</h1>
<p>解释型的最大优势是一次解释，到处可以执行，能够跨平台、跨架构、跨操作系统、跨版本。但是解释型UDF也存在其局限性。主要体现在:</p>
<ul><li>无法使用<code>goto</code>语句</li>
<li>只支持ANSI-C语法</li>
<li>不支持直接数据结构引用(direct data structure references)</li>
<li>不支持局部结构声明</li>
<li>不支持联合体</li>
<li>不支持指向函数的指针</li>
<li><p>不支持函数数组<br />
在访问FLUENT求解器数据的方式上解释式UDF也有限制。解释式UDF不能直接访问存储在FLUENT结构中的数据。它们只能通过使用Fluent提供的宏间接地访问这些数据。另一方面，编译式UDF没有任何C编程语言或其它注意的求解器数据结构的限制。</p>
<h1>在Fluent中解释UDF</h1>
<p>在Fluent中解释UDF非常简单。通常可采用以下步骤:</li>
<li><strong>确保UDF源文件与cas文件在同一目录下。</strong><br />
需要说明的是，在网络式多机并行Fluent中，用户必须共享包含udf源文件、cas文件以及data文件的文件夹。具体共享方法为: 鼠标右键选择要共享的工作文件夹，选择弹出菜单<code>Sharing and Security</code>，并选择<code>Share this folder</code>。</li>
<li><strong>右键选择模型树节点Parameters&amp;Customization→User Defined Functions，选择子菜单Interpreted..</strong><br />
<img referrerpolicy="no-referrer"src="http://i2.muimg.com/588926/61b5158286571a2e.png" /><br />
弹出如下图所示的对话框。<br />
<img referrerpolicy="no-referrer"src="http://i2.muimg.com/588926/da5c07029d28c46c.png" /></li>
<li><strong>在对话框中选择按钮Browse...</strong><br />
在弹出的文件选择对话框中选择UDF源文件。对话框中的其他参数一般情况下可保持默认设置。</li>
<li><strong>点击按钮Interpret解释源文件</strong><br />
源文件解释过程中，TUI窗口会有解释信息。若有错误的话，会出现错误信息。</li>
<li><p><strong>加载解释后的UDF</strong><br />
当源代码被解释后，在相应的GUI窗口中就可以看到被解释的UDF了，此时可以选择使用。</p></li></ul>
<hr />
<p>更多CFD资料可微信扫描下方二维码关注微信公众号。</p>
<p><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/3577886-d669d698a12ddeea.jpg?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e515z8.html">equals&lpar;&rpar;&comma;hashcode&lpar;&rpar;&comma;克隆学习心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kvwm69.html">USACO　滑雪课程</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71myjq.html">19．创建如下三个类：（People类中的三个方法分别输出一些信息，ChinaPeople 和AmericanPeople类重写父类的三个方法）。</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96xgen9.html">写在读ng之前的基础知识----笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1jg2x8.html">HDU 1848</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1n3ej9.html">【转】Delphi多线程学习（9）：多线程数据库查询（ADO）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljmv6k9.html">script：查看redo产生的历史信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj474eq.html">7、Spring&plus;Struts2&plus;MyBaits&lpar;无映射接口实现类&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge4ogl8.html">微信小程序----关于变量对象data  和  前端wxml取后台js变量值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10r6jq.html">Nginx监控-Nginx&plus;Telegraf&plus;Influxb&plus;Grafana</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz61el8.html">【Django】 视图层说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkvk708.html">Java版 人脸识别SDK demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1eeljq.html">Serializable中的serialVersionUID</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4mw1m9.html">NoSQL与MongoDB介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2d7dy9.html">How to create ISO on macOS</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxnr6q.html">SqlServer存储过程&comma;学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jrxg0q.html">js的JSON</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkg3wx8.html">struts2&lowbar;文件上传的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/902r5eoq.html">js  数组的深度递归搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eel0j9.html">【微信小程序】tabBar的显示问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwlvl3y9.html">动态创建radio、checkbox时需要注意的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj2pl68.html">解决sublime的中文乱码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvygymq.html">Debug 路漫漫-01</a>
			</li>
						<li><a href="https://www.batexi.com/a/9630lp39.html">Nginx官方版本说明&num;&num;Mainline &amp;amp&semi;Stable&amp;amp&semi;Legacy versions</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vryr4q.html">自动化运维之Cobbler自动化部署安装操作系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pj3z3q.html">webpack  window  添加ES6支出</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em4xkx9.html">【Algorithm】冒泡排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnv012q.html">numpy 切片</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k5ngoq.html">&lbrack;javase学习笔记&rsqb;-7&period;2 构造函数与一般函数的差别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k510vq.html">关于使用CTE&lpar;公用表表达式&rpar;的递归查询</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
